#########################################
# basic functions

logit <- function(x){1/(1+exp(-x))}
log.odds <- function(x){log(x/(1-x))}
odds <- function(x){(x/(1-x))}

#########################################
# making table and matrices

make.table <- function(out){
coef <- out$par
se <- sqrt(diag(-solve(out$hessian)))
z <- coef/se
p <- 2*(0.5-abs(pnorm(z)-0.5))
res <- round(cbind(coef, se, z, p),3)
res
}

make.2mat <- function(mat){
k <- ncol(mat)
obs <- nrow(mat)
out <- matrix(NA,obs,((k*(k+1))/2 +1))
count <- 0
 for (i in 1:k){
  for (j in 1:i){
   count <- count + 1
   out[,count] <- mat[,i] * mat[,j]
   colnames(out)[c(count,((k*(k+1))/2 +1))] <-
     c(paste(colnames(mat)[i],"*",colnames(mat)[j]), "dummy")
  }
 }
out <- cbind(mat,out[,1:((k*(k+1))/2)])
out
}

make.inter.mat <- function(mat){
k <- ncol(mat)
obs <- nrow(mat)
out <- matrix(NA,obs,((k*(k-1))/2 +1))
count <- 0
 for (i in 2:k){
  for (j in 1:(i-1)){
   count <- count + 1
   out[,count] <- mat[,i] * mat[,j]
   colnames(out)[c(count,((k*(k-1))/2 +1))] <-
     c(paste(colnames(mat)[i],"*",colnames(mat)[j]), "dummy")
  }
 }
out <- cbind(mat,out[,1:((k*(k-1))/2)])
out
}

#########################################
# some statistics

make.tie.time <- function(match.time,match.event){
pair <- length(match.time)/2
j <- 0
tie.time <- matrix(NA,pair,2)
for (i in 1:pair){
if ((match.event[i]==1) & (match.event[i+pair]==1)){
  j <- j+1
  tie.time[j,] <- c(match.time[i],match.time[i+pair])
}
}
tie.time <- tie.time[1:j,]
tie.time
}

make.tie.event <- function(match.event){
pair <- length(match.event)/2
tie.event <- matrix(NA,pair,2)
for (i in 1:pair){
  tie.event[i,] <- c(match.event[i],match.event[i+pair])
}
tie.event
}


