library(Matching)
library(rgenoud)

set.seed(8082007)
start <- date()
GenMatch.boot.out <- GenMatch(Tr=judge$nyjl,
 X=judge.sq, #
 estimand="ATE",
 verbose=TRUE, pop.size = 100, max.generations=200, wait.generations=10, nboots=1000)
# nboots=1000
end <- date()
start
end

attach(judge)

set.seed(9082007)
Match.boot.out <- Match(Y=NY2S1, Tr=nyjl, X=judge.sq,
 estimand="ATE", Weight.matrix=GenMatch.boot.out)

set.seed(1082007)
MB.boot.out <- MatchBalance(nyjl~A1959 + A1960 + A1961 + A1962 + A1963 + A1964 + A1965 + A1966 + A1967 + A1968 +
 nflunk + neliteu + nFstTok, match.out=Match.boot.out, nboots=1000, ks=TRUE, mv=FALSE)
set.seed(2082007)
MB.boot.out.sq <- MatchBalance(nyjl~as.matrix(judge.sq), match.out=Match.boot.out, nboots=1000, ks=TRUE, mv=FALSE)

detach(judge)
save.image("match.Rdata")

MB.boot.out$AfterMatching

summary(MB.boot.out)

id.treat   <- GenMatch.boot.out$matches[,1]
id.control <- GenMatch.boot.out$matches[,2]
judge.match <- rbind(judge[id.treat,],judge[id.control,])

ending <- date()
start
ending










